import socket, ssl, dns.resolver
from tkinter import *


def getDNSRecords(domain):
    answers = []
    try:
        for record in dns.resolver.resolve(domain, 'A'):
            answers.append('IPv4-Adresse: ' + str(record))
    except:
        pass
    try:
        for record in dns.resolver.resolve(domain, 'AAAA'):
            answers.append('IPv6-Adresse: ' + str(record))
    except:
        pass
    if len(answers) == 0:
        return 'Keine Ergebnisse!'
    return '\n'.join(answers)


def getHTTP(request_string, ip, port, mode, hostname=None):
    data = ''
    if mode.get() == 'https':
        try:
            sock = None
            context = ssl.create_default_context()
            if ':' in ip:
                sock = context.wrap_socket(socket.socket(socket.AF_INET6), server_hostname=hostname)
            else:
                sock = context.wrap_socket(socket.socket(socket.AF_INET), server_hostname=hostname)
            sock.connect((ip, port))
            sock.sendall(request_string.replace('\n', '\r\n').encode())
            sock.settimeout(3)
            while True:
                try:
                    raw_data = sock.recv(4096)
                    if len(raw_data) == 0:
                        break
                    data += raw_data.decode().replace('\r\n', '\n')
                except:
                    break
        finally:
            if sock:
                sock.close()
    else:
        try:
            if ':' in ip:
                sock = socket.socket(socket.AF_INET6, socket.SOCK_STREAM)
            else:
                sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            sock.connect((ip, port))
            sock.send(request_string.replace('\n', '\r\n').encode())
            sock.settimeout(3)
            while True:
                try:
                    raw_data = sock.recv(4096)
                    if len(raw_data) == 0:
                        break
                    data += raw_data.decode().replace('\r\n', '\n')
                except:
                    break
        finally:
            sock.close()
    return data


window = Tk()
window.title("Webseiten abrufen mittels HTTP(S)")

dns_lbl = Label(window, text="DNS-Namensauflösung:")
dns_lbl.grid(column=0, row=0, sticky="W")
dns_lbl2 = Label(window, text="URL:")
dns_lbl2.grid(column=0, row=1, sticky="W")
dns_lbl3 = Label(window, text="Antwort:")
dns_lbl3.grid(column=0, row=2, sticky="W")
dns_entry = Entry(window,width=50)
dns_entry.grid(column=1, row=1, sticky="W")
def __dns_resolve():
    dns_text.delete(1.0, END)
    dns_text.insert(END, getDNSRecords(dns_entry.get()))
dns_btn = Button(window, text="Ausführen", command=__dns_resolve)
dns_btn.grid(column=2, row=1, sticky="W")
dns_text = Text(window, width=80, height=10)
dns_text.grid(column=1, row=2, sticky="W")

spacer1 = Label(window, text="")
spacer1.grid(column=0, row=3, sticky="W")

http_mode = StringVar()
http_lbl = Label(window, text="HTTP(S)-Anfrage senden:")
http_lbl.grid(column=0, row=4, sticky="W")
http_frame = Frame(window)
def __select_mode():
    if http_mode.get() == 'https':
        http_lbl4.config(state= "normal")
        http_entry3.config(state= "normal")
    else:
        http_lbl4.config(state="disabled")
        http_entry3.config(state="disabled")
        
http_radio = Radiobutton(http_frame, text='HTTP', value='http', variable=http_mode, command=__select_mode)
http_radio.grid(column=0, row=0, sticky="W")
http_radio2 = Radiobutton(http_frame, text='HTTPS', value='https', variable=http_mode, command=__select_mode)
http_radio2.grid(column=1, row=0, sticky="W")
http_mode.set('http')
http_frame.grid(column=1, row=4, sticky="W")
http_lbl2 = Label(window, text="Server IP-Adresse:")
http_lbl2.grid(column=0, row=5, sticky="W")
http_entry = Entry(window,width=50)
http_entry.grid(column=1, row=5, sticky="W")
http_lbl3 = Label(window, text="Server Port:")
http_lbl3.grid(column=0, row=6, sticky="W")
http_entry2 = Entry(window,width=10)
http_entry2.grid(column=1, row=6, sticky="W")
http_lbl4 = Label(window, text="Server Hostname:", state="disabled")
http_lbl4.grid(column=0, row=7, sticky="W")
http_entry3 = Entry(window,width=50, state="disabled")
http_entry3.grid(column=1, row=7, sticky="W")
http_lbl5 = Label(window, text="Anfragetext:")
http_lbl5.grid(column=0, row=8, sticky="W")
http_text = Text(window, width=80, height=10)
http_text.grid(column=1, row=8, sticky="W")
http_lbl6 = Label(window, text="Antwort:")
http_lbl6.grid(column=0, row=9, sticky="W")
http_text2 = Text(window, width=80, height=15)
http_text2.grid(column=1, row=9, sticky="W")
def __http_request():
    http_text2.delete(1.0, END)
    port = 0
    try:
        port = int(http_entry2.get())
    except:
        http_text2.insert(END, 'Ungültige Portangabe!')
        return
    if port < 0 or port > 65535:
        http_text2.insert(END, 'Ungültige Portangabe!')
        return  
    http_text2.insert(END, getHTTP(http_text.get(1.0, END), ip=http_entry.get(), port=port, mode=http_mode, hostname=http_entry3.get()))
http_btn = Button(window, text="Ausführen", command=__http_request)
http_btn.grid(column=2, row=8, sticky="W")

window.mainloop()
